SELECT
    CAMPAIGN_CODE campaignCode,
    CAMPAIGN_NAME campaignName,
    CAMPAIGN_TYPE campaignType,
    CHANEL chanel,
    START_TIME startTime,
    END_TIME endTime,
    CUSTOMER_NUMBER customerNumber,
    STATUS status
FROM CAMPAIGN
WHERE 1 = 1
    AND (:p_code IS NULL OR (:p_code IS NOT NULL AND UPPER(CAMPAIGN_CODE) LIKE :p_code ))
    AND (:p_name IS NULL OR (:p_name IS NOT NULL AND UPPER(CAMPAIGN_NAME) LIKE :p_name ))
    AND (:p_status IS NULL OR (:p_status IS NOT NULL AND STATUS = :status))
    AND ((:p_frDateFr IS NULL AND :p_frDateTo IS NULL)
             OR ((:p_frDateFr IS NOT NULL AND :p_frDateTo IS NOT NULL) AND
                 (trunc(START_TIME) BETWEEN TO_DATE(:p_frDateFr, 'YYYYMMDD') AND TO_DATE(:p_frDateTo, 'YYYYMMDD')))
             OR ((:p_frDateFr IS NOT NULL AND :p_frDateTo IS NULL)
                 AND (trunc(START_TIME) >= TO_DATE(:p_frDateFr, 'YYYYMMDD')))
             OR ((:p_frDateFr IS NULL AND :p_frDateTo IS NOT NULL)
                 AND (trunc(START_TIME) <= TO_DATE(:p_frDateTo, 'YYYYMMDD')))
    )
    AND ((:p_toDateFr IS NULL AND :p_toDateTo IS NULL)
             OR ((:p_toDateFr IS NOT NULL AND :p_toDateTo IS NOT NULL) AND
                 (trunc(END_TIME) BETWEEN TO_DATE(:p_toDateFr, 'YYYYMMDD') AND TO_DATE(:p_toDateTo, 'YYYYMMDD')))
             OR ((:p_toDateFr IS NOT NULL AND :p_toDateTo IS NULL)
                 AND (trunc(END_TIME) >= TO_DATE(:p_toDateFr, 'YYYYMMDD')))
             OR ((:p_toDateFr IS NULL AND :p_toDateTo IS NOT NULL)
                 AND (trunc(END_TIME) <= TO_DATE(:p_toDateTo, 'YYYYMMDD')))
    )
    AND (:p_type IS NULL OR (:p_type IS NOT NULL AND CAMPAIGN_TYPE = :p_type))
    AND (:p_chanel IS NULL OR (:p_chanel IS NOT NULl AND CHANEL = :p_chanel))
